package cokr.xit.fims.sndb.service;

import java.util.List;

import cokr.xit.fims.sndb.SndbQuery;
import cokr.xit.fims.sndb.Sndng;
import cokr.xit.foundation.data.DataObject;
import cokr.xit.foundation.data.DataProc;

/**발송 대장 관리 서비스 인터페이스.
*
* <p>상세 설명:
*
* <pre>
* ============ 변경 이력 ============
* 2023-08-25	JoJH 최초 작성
* ================================
* </pre>
*/
public interface SndngService {

	/**지정한 조건에 따라 계고장 발송 대상 목록을 조회하여 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	List<DataObject> getWrngTrgtList(SndbQuery req);

	/**지정한 조건에 따라 계고장 발송 대상 객체들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 객체 목록
	 */
	List<DataObject> getWrngTrgts(SndbQuery req);

	/**지정한 조건에 따라 계고장 발송 대장 목록을 조회하여 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	List<DataObject> getWrngSndngList(SndbQuery req);

    /**계고장 발송 대상을 발송 대장에 등록한다.
     * @param req 계고장 발송 대상 조회, sndng 발송 대장
     * @return 저장 여부
     * <ul><li>저장됐으면 true</li>
     *     <li>그렇지 않으면 false</li>
     * </ul>
     */
	DataProc createWrngSndngList(SndbQuery req, Sndng sndng);

    /**계고장 발송 대장 정보를 삭제한다.
     * @param sndng 발송 대장
     * @return 저장 여부
     * <ul><li>저장됐으면 true</li>
     *     <li>그렇지 않으면 false</li>
     * </ul>
     */
    String removeWrngSndng(Sndng sndng);

	/**지정한 조건에 따라 사전통지 발송 대상 목록을 조회하여 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	List<DataObject> getAdvntceTrgtList(SndbQuery req);

	/**지정한 조건에 따라 사전통지 발송 대상 객체들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 객체 목록
	 */
	List<DataObject> getAdvntceTrgts(SndbQuery req);

	/**지정한 조건에 따라 사전통지 발송 대장 목록을 조회하여 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	List<DataObject> getAdvntceSndngList(SndbQuery req);

    /**사전통지 발송 대상을 발송 대장에 등록한다.
     * @param req 계고장 발송 대상 조회, sndng 발송 대장
     * @return 저장 여부
     * <ul><li>저장됐으면 true</li>
     *     <li>그렇지 않으면 false</li>
     * </ul>
     */
    DataProc createAdvntceSndngList(SndbQuery req, Sndng sndng);

    /**사전통지 발송 대장 정보를 삭제한다.
     * @param sndng 발송 대장
     * @return 저장 여부
     * <ul><li>저장됐으면 true</li>
     *     <li>그렇지 않으면 false</li>
     * </ul>
     */
    String removeAdvntceSndng(Sndng sndng);

	/**지정한 조건에 따라 고지서 발송 대상 목록을 조회하여 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	List<DataObject> getNhtTrgtList(SndbQuery req);

	/**지정한 조건에 따라 고지서 발송 대상 객체들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 객체 목록
	 */
	List<DataObject> getNhtTrgts(SndbQuery req);

	/**고지서 발송 대상을 조회하여 발송 대장에 등록한다.
	 * @param req 계고장 발송 대상 조회, sndng 발송 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	DataProc createNhtSndngList(SndbQuery req, Sndng sndng);

	/**지정한 조건에 따라 고지서 발송 대장 목록을 조회하여 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	List<DataObject> getNhtSndngList(SndbQuery req);

	/**지정한 조건에 따라 발송 대장 목록을 조회하여 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	List<DataObject> getSndngList(SndbQuery req);

	/**지정한 조건에 따라 발송 대장 객체들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 객체 목록
	 */
	List<Sndng> getSndngs(SndbQuery req);

	/**전자우편(EPost) 대장 정보를 등록한다.
	 * @param sndng 발송 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	String createSndngLink(Sndng sndng);

	/**발송 대장 정보를 삭제한다.
	 * @param sndng 발송 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	String removeSndng(Sndng sndng);

}
